package com.zskk.dicom.monitor.monitors;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.report.ErrReporter;
import org.apache.http.util.TextUtils;

import java.io.File;

/**
 * 文件夹监听程序
 */
public class BaseFileChangeProc {

    /**
     * 监听目录
     */
    private String monitorDir = null;

    /**
     * 监听回调
     */
    private FileActionCallback fileActionCallback = null;

    public BaseFileChangeProc(String monitorDir, FileActionCallback fileActionCallback) {
        this.monitorDir = monitorDir;
        this.fileActionCallback = fileActionCallback;
    }

    /**
     * 开始监听
     */
    public void startMonitor() {
        String monitorDir = this.monitorDir;
        String msg = null;
        if (TextUtils.isEmpty(monitorDir)) {
            msg = "error, the monitor dir con't is null!";
            Configs.sysLog.error(msg);
            ErrReporter.report(msg);
            return;
        }
        final File file = new File(monitorDir);
        if(!file.exists() || !file.isDirectory()) {
            msg = "error, the monitor dir not exists or is file";
            Configs.sysLog.error(msg);
            ErrReporter.report(msg);
            return;
        }

        try {
            new WatchDir(file, true, fileActionCallback);
        } catch (Exception e) {
            e.printStackTrace();
        }
        Configs.sysLog.info("--------------------------------------------------\n Monitoring:" + file.getAbsolutePath() + "\t >>> ");
    }

}
