package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.queue.IQueue;
import org.apache.commons.io.FileUtils;

import java.io.File;
import java.util.Iterator;

public abstract class BaseAddHistory2QueueRunner implements Runnable{
    /**
     * 监听目录路径
     */
    private String monitorDir = null;

    /**
     * 匹配后缀数组
     */
    private String[] suffixs = null;

    /**
     * 加入的队列
     */
    private IQueue<String> queue = null;

    public BaseAddHistory2QueueRunner(String monitorDir, IQueue<String> queue) {
        this(monitorDir, queue, new String[] { "dcm" });
    }

    public BaseAddHistory2QueueRunner(String monitorDir, IQueue<String> queue, String[] suffixs) {
        this.monitorDir = monitorDir;
        this.queue = queue;
        this.suffixs = suffixs;
    }

    @Override
    public void run() {
        addHistory2Queue();
    }

    protected void addHistory2Queue() {
        File dir = new File(this.monitorDir);
        Iterator<File> its = FileUtils.iterateFiles(dir, suffixs, true);
        while (its.hasNext()) {
            File file = its.next();
            if(file.exists() && file.isFile()) {
                queue.push(file.getAbsolutePath());
            }
        }
    }
}