package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.queue.*;
import com.zskk.dicom.monitor.uploader.BaseFileUploader;

import java.util.concurrent.TimeUnit;

public class CurrentUploadRunner extends AbstractUpload implements Runnable{
    @Override
    protected boolean upload(String filePath) {
        return BaseFileUploader.upload(filePath, SuccessQueue.getInstance(), RemoveFile2RetryQueue.getInstance());
    }

    @Override
    protected String getUploadFilePath() {
        return (String) CurrentUploadQueue.getInstance().pop();
    }
    @Override
    public void run() {
        while(true) {
            try {
                if(CurrentUploadQueue.getInstance().empty()) {
                    Configs.sysLog.warn("CurrentUploadQueue is empty");
                    TimeUnit.SECONDS.sleep(1);
                }
                if(upload()) {
                    Configs.sysLog.info("CurrentUploadRunner upload success ");
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    Configs.sysLog.warn("CurrentUploadRunner upload error ");
                    TimeUnit.SECONDS.sleep(1);
                }

            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
