package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.queue.ErrorQueue;
import com.zskk.dicom.monitor.utils.MonitorFileUtils;

public class ErrorRunner extends BaseRemoveRunner {

    @Override
    protected boolean exit() {
        return false;
    }

    @Override
    protected String getRunnerName() {
        return "ErrorRunner";
    }

    @Override
    protected boolean empty() {
        return ErrorQueue.getInstance().empty();
    }

    @Override
    protected int size() {
        return ErrorQueue.getInstance().size();
    }

    @Override
    protected String getQueueName() {
        return "ErrorQueue";
    }

    @Override
    protected String getSourceFilePath() {
        return (String) ErrorQueue.getInstance().pop();
    }

    @Override
    protected String getTargetFilePath(String sourceFilePath) {
        return MonitorFileUtils.getErrorPath(sourceFilePath);
    }
}
