package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.queue.OldUploadQueue;
import com.zskk.dicom.monitor.queue.RemoveFile2RetryQueue;
import com.zskk.dicom.monitor.queue.SuccessQueue;
import com.zskk.dicom.monitor.uploader.BaseFileUploader;

import java.util.concurrent.TimeUnit;

public class HistoryUploadRunner extends AbstractUpload implements Runnable{
    @Override
    protected boolean upload(String filePath) {
        return BaseFileUploader.upload(filePath, SuccessQueue.getInstance(), RemoveFile2RetryQueue.getInstance());
    }

    @Override
    protected String getUploadFilePath() {
        return (String) OldUploadQueue.getInstance().pop();
    }

    @Override
    public void run() {
        while(true) {
            try {
                if(OldUploadQueue.getInstance().empty()) {
                    Configs.sysLog.warn("OldUploadQueue is empty");
                    return;
                }
                if(upload()) {
                    Configs.sysLog.info("HistoryUploadRunner upload success");
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    Configs.sysLog.warn("HistoryUploadRunner upload fail");
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
