package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.queue.RemoveFile2RetryQueue;
import com.zskk.dicom.monitor.utils.MonitorFileUtils;

public class RemoveFile2RetryRunner extends BaseRemoveRunner {

    @Override
    protected boolean exit() {
        return false;
    }

    @Override
    protected String getRunnerName() {
        return "RemoveFile2RetryRunner";
    }

    @Override
    protected boolean empty() {
        return RemoveFile2RetryQueue.getInstance().empty();
    }

    @Override
    protected int size() {
        return RemoveFile2RetryQueue.getInstance().size();
    }

    @Override
    protected String getQueueName() {
        return "RemoveFile2RetryQueue";
    }

    @Override
    protected String getSourceFilePath() {
        return (String) RemoveFile2RetryQueue.getInstance().pop();
    }

    @Override
    protected String getTargetFilePath(String sourceFilePath) {
        return MonitorFileUtils.getRetryFilePath(sourceFilePath);
    }
}
