package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.queue.ErrorQueue;
import com.zskk.dicom.monitor.queue.OldRetryQueue;
import com.zskk.dicom.monitor.queue.SuccessQueue;
import com.zskk.dicom.monitor.uploader.BaseFileUploader;

import java.util.concurrent.TimeUnit;

public class RetryHistoryUploadRunner extends AbstractUpload implements Runnable{
    @Override
    protected boolean upload(String filePath) {
        return BaseFileUploader.upload(filePath, SuccessQueue.getInstance(), ErrorQueue.getInstance());
    }

    @Override
    protected String getUploadFilePath() {
        return (String) OldRetryQueue.getInstance().pop();
    }

    @Override
    public void run() {
        while(true) {
            boolean flag = upload();
            try {
                if(OldRetryQueue.getInstance().empty()) {
                    Configs.sysLog.warn("OldRetryQueue is empty");
                    return;
                }
                if(upload()) {
                    Configs.sysLog.warn("RetryHistoryUploadRunner is success");
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    Configs.sysLog.warn("RetryHistoryUploadRunner is fail");
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
