package com.zskk.dicom.monitor.runner;

import com.zskk.dicom.monitor.queue.SuccessQueue;
import com.zskk.dicom.monitor.utils.MonitorFileUtils;

public class SuccessRunner extends BaseRemoveRunner {

    @Override
    protected boolean exit() {
        return false;
    }

    @Override
    protected String getRunnerName() {
        return "SuccessRunner";
    }

    @Override
    protected boolean empty() {
        return SuccessQueue.getInstance().empty();
    }

    @Override
    protected int size() {
        return SuccessQueue.getInstance().size();
    }

    @Override
    protected String getQueueName() {
        return "SuccessQueue";
    }

    @Override
    protected String getSourceFilePath() {
        return (String) SuccessQueue.getInstance().pop();
    }

    @Override
    protected String getTargetFilePath(String sourceFilePath) {
        return MonitorFileUtils.getBackupPath(sourceFilePath);
    }
}
