package com.zskk.dicom.monitor.schedules;

import com.zskk.dicom.monitor.runner.*;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 *
 * 功能描述:
 *
 * @param: dirMonitorPools 监控文件线程池 oldUploadPools 旧文件
 * @return:
 * @auther: zzp
 * @date: 2019/3/10 10:35
 */
public class StatRunner {

/*
    //手动创建线程池
    private static  ThreadFactory namedThreadFactory = new ThreadFactoryBuilder().setNameFormat("dirMonitorThread-call-runner-%d").build();
    private static  ExecutorService dirMonitorPools = new ThreadPoolExecutor(1,1,0L,TimeUnit.MILLISECONDS,new LinkedBlockingQueue<Runnable>(),namedThreadFactory);
    private static  ThreadFactory namedThreadFactory1 = new ThreadFactoryBuilder().setNameFormat("oldUploadThread-call-runner-%d").build();
    private static  ExecutorService oldUploadPools = new ThreadPoolExecutor(1,2,0L,TimeUnit.MILLISECONDS,new LinkedBlockingQueue<Runnable>(),namedThreadFactory1);
    private static  ThreadFactory namedThreadFactory2 = new ThreadFactoryBuilder().setNameFormat("currentUploadThread-call-runner-%d").build();
    private static  ExecutorService currentUploadPools = new ThreadPoolExecutor(1,2,0L,TimeUnit.MILLISECONDS,new LinkedBlockingQueue<Runnable>(),namedThreadFactory2);
    private static  ThreadFactory namedThreadFactory3 = new ThreadFactoryBuilder().setNameFormat("addHistoryFileThread-call-runner-%d").build();
    private static  ExecutorService addHistoryFile2UploadPools = new ThreadPoolExecutor(1,2,0L,TimeUnit.MILLISECONDS,new LinkedBlockingQueue<Runnable>(),namedThreadFactory3);
*/
//    private static ExecutorService oldUploadPools = null;
//    //新
//    private static ExecutorService currentUploadPools = null;
//    //历史文件记录
////    private static ExecutorService addHistoryFile2UploadPools = null;
//    //成功备份移除
//    private static ExecutorService successPools = null;
//    //重试上传线程
//    private static ExecutorService retryUploadPools = null;


    /**
     * 文件监听线程(池)
     */
    private static ExecutorService dirMonitorPools = null;
    private static ExecutorService retryMonitorPools = null;

    private static ExecutorService addHistoryFile2UploadPools = null;
    private static ExecutorService addHistoryRetryFile2UploadPools = null;

    private static ExecutorService oldUploadPools = null;
    private static ExecutorService currentUploadPools = null;
    private static ExecutorService oldRetryPools = null;
    private static ExecutorService currentRetryPools = null;

    private static ExecutorService successPools = null;
    private static ExecutorService errorPools = null;
    private static ExecutorService remove2RetryPools = null;


    public static void start() {
        //监听目标文件
        dirMonitorPools = generateSinglePools(dirMonitorPools);
        dirMonitorPools.execute(new DirMonitor());

        //监听重试文件
        retryMonitorPools = generateSinglePools(retryMonitorPools);
        retryMonitorPools.execute(new RetryDirMonitor());

        //老文件加入老上传队列
        addHistoryFile2UploadPools = generateSinglePools(addHistoryFile2UploadPools);
        addHistoryFile2UploadPools.execute(new AddHistory2QueueRunner());

        //老重试文件加入老重试上传队列
        addHistoryRetryFile2UploadPools = generateSinglePools(addHistoryRetryFile2UploadPools);
        addHistoryRetryFile2UploadPools.execute(new AddRetryHistory2QueueRunner());

        //老文件or重试放入队列
//        addHistoryFile2UploadPools = generatePools(addHistoryFile2UploadPools, 2);
//        addHistoryFile2UploadPools.execute(new HistoryFileQuenuRunner());
        try {
            TimeUnit.SECONDS.sleep(1);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        // 老文件上传
        oldUploadPools = generatePools(oldUploadPools, 2);
        oldUploadPools.execute(new HistoryUploadRunner());

        // 新文件上传
        currentUploadPools = generatePools(currentUploadPools, 2);
        currentUploadPools.execute(new CurrentUploadRunner());

        //老重试上传
        oldRetryPools = generatePools(oldRetryPools, 2);
        oldRetryPools.execute(new RetryHistoryUploadRunner());

        //新重试上传
        currentRetryPools = generatePools(currentRetryPools, 2);
        currentRetryPools.execute(new RetryCurrentUploadRunner());

        //成功移动文件
        successPools = generatePools(successPools, 2);
        successPools.execute(new SuccessRunner());

        //错误移动文件
        errorPools = generateSinglePools(errorPools);
        errorPools.execute(new ErrorRunner());

        //重试移动文件
        remove2RetryPools = generateSinglePools(remove2RetryPools);
        remove2RetryPools.execute(new RemoveFile2RetryRunner());
        // 成功备份移除
//        successPools = generatePools(successPools, 2);
//        successPools.execute(new SuccessUploadQuenu());
//        // 老上传
//        oldUploadPools = generatePools(oldUploadPools, 2);
//        oldUploadPools.execute(new CurrentUploadRunner());
//        // oldUploadPools.execute(new FileUploadsOss(UploadsQueue.fileQueue));
//        // oldUploadPools.execute(new CurrentUploadRunner());
//        // oldUploadPools.execute(new FileUploadsOss(FileUploadsOss.FLAG_UPLOAD));
//        // 新上传
//        currentUploadPools = generatePools(currentUploadPools, 2);
//        currentUploadPools.execute(new CurrentUploadRunner());
//        // 重试上传
//        retryUploadPools = generatePools(retryUploadPools, 2);
//        retryUploadPools.execute(new RetryUploadRunner());
        // retryUploadPools.execute(new FileUploadsOss(UploadsQueue.failFileQueue));
        // retryUploadPools.execute(new RetryUploadRunner());
        // retryUploadPools.execute(new FileUploadsOss(FileUploadsOss.FLAG_RETRY));

    }

    public static ExecutorService generatePools(ExecutorService oldPool, int length) {
        if (oldPool != null && !oldPool.isTerminated()) {
            oldPool.shutdown();
            while (oldPool.isTerminated()) {
                try {
                    oldPool.awaitTermination(200, TimeUnit.MILLISECONDS);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
        if(length == 1) {
           return Executors.newSingleThreadExecutor();
        }
        return Executors.newFixedThreadPool(length);
    }

    public static ExecutorService generateSinglePools(ExecutorService oldPool) {
        return generatePools(oldPool, 1);
    }

}
